;********************************************************************
;*             20.07.2004  (Team HomeWork)              *
;*                   e-mail: sne_pro@mail.ru                        *
;********************************************************************
	include		windows.inc
	include 	kernel32.inc
	include 	user32.inc

	includelib 	kernel32.lib
	includelib	user32.lib

jmp_far struct
	instr_push		db	?					;  push
	arg				dd	?					;   push
	instr_ret		db 	?					;  ret
jmp_far ends

.data?
	hcProcess		dd	?					;  
	hInstance		dd	?					;  dll ...
	s_hFileMap		dd	?					;     ProcessID

	oldData			db 6h	dup(?)			;    6-    
	written			dd	?					;   - / 
	adr_APIFunction dd	?					;   
	jump			jmp_far	<?>				;  

	sShare			db	30h dup(?)			;        (ProcessId)

.data
	sModuleName		db	"ntdll.dll", 0h		; 
	sFunctnName		db	"NtQuerySystemInformation", 0h

	hHook			dd	0					;  

.const
	SystemProcessInformation equ 5h  

.code

fnReplace proc uses esi dwChar:BYTE
	mov esi, offset sShare
@loop:
	mov al, byte ptr [esi]
	or	al, al
	jz	@ret
	cmp al, dwChar
	jne	@F
	mov byte ptr [esi], '_'
@@:
	inc esi
	jmp @loop
@ret: 
	ret
fnReplace endp

; ################################################
;	 DWORD  ...
; ################################################

;    
SetShareDword proc uses esi dwValue:DWORD
	invoke CreateFileMapping, INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, \
 				0h, 4h, offset sShare			; ,   ,  FileMapping
	or eax, eax
	jz	@ret

	mov s_hFileMap, eax

	invoke GetLastError							;   - !?
	cmp	eax, ERROR_ALREADY_EXISTS
	jne	@F

 	invoke CloseHandle, s_hFileMap				;   
@@:
	invoke MapViewOfFile, s_hFileMap, FILE_MAP_READ or FILE_MAP_WRITE, 0h, 0h, 0h
	or	eax, eax
	jz	@ret

	push eax									;   pView

	push dwValue								;      eax (pView)
	pop dword ptr [eax]

	call UnmapViewOfFile						; pView   
@ret:
	ret
SetShareDword endp

;   
GetShareDword proc
	LOCAL ret_val:DWORD
	invoke OpenFileMapping, FILE_MAP_READ Or FILE_MAP_WRITE, FALSE, offset sShare
	or	eax, eax
	jz	@ret

	push eax									; hFileMapT

	invoke MapViewOfFile, eax, FILE_MAP_READ Or FILE_MAP_WRITE, 0h, 0h, 0h
	or	eax, eax								; pView here
	jz	@F

	push eax									; pView  

	push dword ptr [eax]						;        ret_val
	pop eax
	mov ret_val, eax 

	call UnmapViewOfFile						; pView   
@@:
	call CloseHandle							; hFileMapT   
	mov eax, ret_val							;  
@ret:
	ret
GetShareDword endp

;  
DelShareDword proc
	invoke CloseHandle, s_hFileMap
	ret
DelShareDword endp